<template>
  <div class="layout" :style="{ width: `${layoutWidth}px` }">
    <aside class="menu" :class="{ 'menu--opened': isMenuOpened }">
      <div @click="changeMenuStatus" class="menu-title">
        <img class="title-logo" src="@/assets/images/wplay_logo.svg" alt="" height="25px">
        <div v-if="isMenuOpened" class="title-text">
          wPlay
        </div>
      </div>
      <div class="menu-content"
        v-if="activeMenu === 'main'">
        <menu-item v-for="(item, index) in filteredMainMenuLinks" :key="index"
          :text="item.text" :link="item.link" :icon="item.icon"
          :showText="isMenuOpened"/>
      </div>
      <div class="menu-content"
         v-if="activeMenu === 'admin'">
        <menu-item v-for="(item, index) in filteredAdminMenuLinks" :key="index"
          :text="item.text" :link="item.link" :icon="item.icon"
          :showText="isMenuOpened"/>
      </div>
      <div class="menu-content"
         v-if="activeMenu === 'orgadmin'">
        <menu-item v-for="(item, index) in filteredOrganizationMenuLinks" :key="index"
          :text="item.text" :link="item.link" :icon="item.icon"
          :showText="isMenuOpened"/>
      </div>
    </aside>
    <div class="masonry">
      <router-view :style="{ width: `${masonryWidth}px` }"/>
    </div>
  </div>
</template>

<script>
import { mapActions, mapState, mapGetters } from 'vuex';

import {
  MasonryGlobalMargins,
  MasonryColumnWidth,
  MasonryGutter,
  PermissionsTypes,
} from '@/shared';
import { IsAccessAllowed } from '@/store/session/actions';

import MenuItem from '@/components/layout/MenuItem.vue';

export default {
  name: 'Base',
  components: {
    MenuItem,
  },
  data() {
    return {
      isMenuOpened: false,
    };
  },
  computed: {
    ...mapState('session', ['selectedOrganization', 'permissions']),
    ...mapState('organization', ['organization']),
    ...mapGetters('session', ['isOrganizationSelected', 'isUserAdmin']),
    masonryWidth() {
      const maxMasonryWidth = window.innerWidth - MasonryGlobalMargins;
      let masonryWidth = 0;
      while (maxMasonryWidth - masonryWidth >= MasonryColumnWidth) {
        masonryWidth += MasonryColumnWidth + MasonryGutter;
      }
      masonryWidth -= MasonryGutter;
      return masonryWidth;
    },
    layoutWidth() {
      return this.masonryWidth + MasonryGlobalMargins;
    },
    activeMenu() {
      switch (this.$route.name.split('/')[0]) {
        case 'admin': return 'admin';
        case 'orgadmin': return 'orgadmin';
        default: return 'main';
      }
    },
    mainMenuLinks() {
      return [
        {
          link: 'admin',
          icon: 'crutch',
          text: 'Администрирование',
          showCondition: this.isUserAdmin,
        },
        {
          link: 'dashboard',
          icon: 'tachometer-alt',
          text: 'Панель управления',
        },
        {
          link: 'orgadmin',
          icon: 'university',
          text: 'Организация',
          showCondition: this.isOrganizationSelected,
          requiredPermissions: [
            {
              organization: this.selectedOrganization,
              type: PermissionsTypes.Organization,
              resource: null,
              crud: {
                read: true,
              },
            },
            {
              organization: this.selectedOrganization,
              type: PermissionsTypes.Members,
              resource: null,
              crud: {
                read: true,
              },
            },
            {
              organization: this.selectedOrganization,
              type: PermissionsTypes.Roles,
              resource: null,
              crud: {
                read: true,
              },
            },
            {
              organization: this.selectedOrganization,
              type: PermissionsTypes.Reasons,
              resource: null,
              crud: {
                read: true,
              },
            },
            {
              organization: this.selectedOrganization,
              type: PermissionsTypes.Categories,
              resource: null,
              crud: {
                read: true,
              },
            },
            {
              organization: this.selectedOrganization,
              type: PermissionsTypes.Groups,
              resource: null,
              crud: {
                read: true,
              },
            },
            {
              organization: this.selectedOrganization,
              type: PermissionsTypes.Grades,
              resource: null,
              crud: {
                read: true,
              },
            },
          ],
        },
        {
          link: 'profile',
          icon: 'user-alt',
          text: 'Профиль',
          showCondition: false,
        },
        {
          link: 'issued_grade_changes',
          icon: 'exchange-alt',
          text: 'Выставление баллов',
          showCondition: this.isOrganizationSelected,
          requiredPermissions: [{
            organization: this.selectedOrganization,
            type: PermissionsTypes.Grades,
            resource: undefined,
            crud: {
              update: true,
            },
          }],
        },
        {
          link: 'logout',
          icon: 'sign-out-alt',
          text: 'Выход',
        },
      ];
    },
    filteredMainMenuLinks() {
      return this.mainMenuLinks.filter(link => this.filterMenuLink(link));
    },
    organizationMenuLinks() {
      if (!this.selectedOrganization) return [];
      return [
        {
          link: 'dashboard',
          icon: 'arrow-left',
          text: 'В основной раздел',
        },
        {
          link: 'orgadmin/dashboard',
          icon: 'university',
          text: 'Панель управления',
          requiredPermissions: [],
        },
        {
          link: 'orgadmin/users',
          icon: 'user-alt',
          text: 'Пользователи',
          requiredPermissions: [],
        },
        {
          link: 'orgadmin/roles',
          icon: 'address-card',
          text: 'Роли',
          requiredPermissions: [],
        },
        {
          link: 'orgadmin/categories',
          icon: 'list-ul',
          text: 'Категории',
          requiredPermissions: [],
          showCondition: this.organization.categories_enabled,
        },
        {
          link: 'orgadmin/groups',
          icon: 'users',
          text: 'Команды',
          requiredPermissions: [],
          showCondition: this.organization.teamplay_enabled,
        },
        {
          link: 'orgadmin/reasons',
          icon: 'exchange-alt',
          text: 'Причины',
          requiredPermissions: [],
          showCondition: this.organization.reasons_enabled,
        },
      ];
    },
    filteredOrganizationMenuLinks() {
      return this.organizationMenuLinks.filter(link => this.filterMenuLink(link));
    },
    adminMenuLinks() {
      return [
        {
          link: 'dashboard',
          icon: 'arrow-left',
          text: 'В основной раздел',
        },
        {
          link: 'admin/organizations',
          icon: 'university',
          text: 'Организации',
        },
      ];
    },
    filteredAdminMenuLinks() {
      return this.adminMenuLinks.filter(link => this.filterMenuLink(link));
    },
  },
  methods: {
    ...mapActions('session', ['isAccessAllowed']),
    changeMenuStatus() {
      this.isMenuOpened = !this.isMenuOpened;
    },
    filterMenuLink(menuLink) {
      const parsedPermissions = this.parseRequiredPermissions(menuLink.requiredPermissions);
      if (menuLink.showCondition === undefined) return parsedPermissions;
      return menuLink.showCondition && parsedPermissions;
    },
    parseRequiredPermissions(requiredPermissions) {
      if (requiredPermissions) {
        return IsAccessAllowed(this.permissions, requiredPermissions, this.isUserAdmin);
      }
      return true;
    },
  },
};
</script>

<style lang="scss" scoped>
.layout {
  position: relative;
  box-sizing: border-box;
  padding: $minimalContentMargins;
  display: flex;
  justify-content: center;
  align-items: flex-start;

  .menu {
    position: sticky;
    top: 60px;
    margin: 60px $menuMargin 0 0;
    width: $menuWidth;
    display: flex;
    flex-direction: column;
    justify-content: flex-start;
    align-items: stretch;
    background: #fff;
    border-radius: 10px;
    overflow-x: hidden;
    transition: width ease-in-out .2s;

    &--opened {
      width: 220px;
    }

    &-content {
      display: flex;
      flex-direction: column;
      justify-content: flex-start;
      align-items: stretch;
    }

    &-title {
      height: 60px;
      display: flex;
      justify-content: flex-start;
      align-items: center;

      &:hover {
        cursor: pointer;
      }

      .title {

        &-logo {
          margin-left: 21px;
        }

        &-text {
          margin-left: 10px;
          color: #000;
          font-size: 32px;
          font-family: $firaSans;
          text-decoration: none;
        }

      }

    }

  }

  .masonry {
    margin-right: $menuWidth + $menuMargin;
  }

}
</style>
